MINCORE(2)

NAME
mincore - determine residency of memory pages

LIBRARY
libc

SYNOPSIS
#include <sys/mman.h>
int
mincore(const void *addr, size_t len, char *vec);

DESCRIPTION
The mincore() system call determines whether each of the pages in the region beginning at addr and continuing for len bytes is resident. The status is returned in the vec array, one character per page. Each character is either 0 if the page is not resident, or a combination of the following flags (defined in <sys/mman.h>):

MINCORE_INCORE
    Page is in core (resident).

MINCORE_REFERENCED
    Page has been referenced by us.

MINCORE_MODIFIED
    Page has been modified by us.

MINCORE_REFERENCED_OTHER
    Page has been referenced.

MINCORE_MODIFIED_OTHER
    Page has been modified.

MINCORE_SUPER
    Page is part of a "super" page. (only i386 & amd64)

The information returned by mincore() may be out of date by the time the system call returns. The only way to ensure that a page is resident is to lock it into memory with the mlock(2) system call.

RETURN VALUES

ERRORS
The mincore() system call will fail if:

[ENOMEM]
    The virtual address range specified by the addr and len arguments is not fully mapped.

[EFAULT]
    The vec argument points to an illegal address.

SEE ALSO
madvise(2), mlock(2), mprotect(2), msync(2), munmap(2), getpagesize(3)

HISTORY
The mincore() system call first appeared in 4.4BSD.